// MiniPaintView.cpp : implementation of the CMiniPaintView class
//

#include "stdafx.h"
#include "MiniPaint.h"

#include "MiniPaintDoc.h"
#include "MiniPaintView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiniPaintView

IMPLEMENT_DYNCREATE(CMiniPaintView, CView)

BEGIN_MESSAGE_MAP(CMiniPaintView, CView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CMiniPaintView construction/destruction

CMiniPaintView::CMiniPaintView()
: m_Dragging(0)
, m_PointOld(0)
, m_PointOrigin(0)
, m_ClassName(_T(""))
{
	// TODO: add construction code here
m_HCross = AfxGetApp ()->LoadStandardCursor (IDC_CROSS); 
}

CMiniPaintView::~CMiniPaintView()
{
}

BOOL CMiniPaintView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
   m_ClassName = AfxRegisterWndClass
	  (CS_HREDRAW | CS_VREDRAW,             //  
	  0,				       //  
	  (HBRUSH):: GetStockObject (WHITE_BRUSH),
				      //     
	  0);           //   
	//  ::LoadIcon(NULL, (LPCSTR)IDR_MAINFRAME));
   cs.lpszClass = m_ClassName;

	return CView::PreCreateWindow(cs);
}

// CMiniPaintView drawing

void CMiniPaintView::OnDraw(CDC* /*pDC*/)
{
	CMiniPaintDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}


// CMiniPaintView diagnostics

#ifdef _DEBUG
void CMiniPaintView::AssertValid() const
{
	CView::AssertValid();
}

void CMiniPaintView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMiniPaintDoc* CMiniPaintView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMiniPaintDoc)));
	return (CMiniPaintDoc*)m_pDocument;
}
#endif //_DEBUG


// CMiniPaintView message handlers

void CMiniPaintView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
     m_PointOrigin = point;
     m_PointOld = point;
     SetCapture ();
     m_Dragging = 1;
     RECT Rect;
     GetClientRect (&Rect);
     ClientToScreen (&Rect);
     ::ClipCursor (&Rect);
     

	CView::OnLButtonDown(nFlags, point);
}

void CMiniPaintView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
if (m_Dragging)
    {
    m_Dragging = 0;
    ::ReleaseCapture ();
    ::ClipCursor (NULL);
    CClientDC ClientDC (this);
    ClientDC.SetROP2 (R2_NOT);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (m_PointOld);
    ClientDC.SetROP2 (R2_COPYPEN);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (point);
    }

	CView::OnLButtonUp(nFlags, point);
}


void CMiniPaintView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
 ::SetCursor (m_HCross);
 if (m_Dragging)
    {
    CClientDC ClientDC (this);
    ClientDC.SetROP2 (R2_NOT);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (m_PointOld);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (point);
    m_PointOld = point;
    }

	CView::OnMouseMove(nFlags, point);
}
