// FormatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FontDemo.h"
#include "FormatDlg.h"


// CFormatDlg dialog

IMPLEMENT_DYNAMIC(CFormatDlg, CDialog)
CFormatDlg::CFormatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormatDlg::IDD, pParent)
	, m_Bold(FALSE)
	, m_Italic(FALSE)
	, m_Underline(FALSE)
	, m_Justify(0)
	, m_Pitch(0)
	, m_Spacing(0)
{
}

CFormatDlg::~CFormatDlg()
{
}

void CFormatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_BOLD, m_Bold);
	DDX_Check(pDX, IDC_ITALIC, m_Italic);
	DDX_Check(pDX, IDC_UNDERLINE, m_Underline);
	DDX_Radio(pDX, IDC_LEFT, m_Justify);
	DDX_Radio(pDX, IDC_VARIABLE, m_Pitch);
	DDX_Text(pDX, IDC_SPACING, m_Spacing);
	DDV_MinMaxInt(pDX, m_Spacing, 1, 3);
	DDX_Control(pDX, IDC_SPACING, m_SpacingEdit);
}


BEGIN_MESSAGE_MAP(CFormatDlg, CDialog)

	ON_BN_CLICKED(IDC_CENTER, OnCenter)
	ON_BN_CLICKED(IDC_BOLD, OnBold)
	ON_BN_CLICKED(IDC_ITALIC, OnItalic)
	ON_BN_CLICKED(IDC_UNDERLINE, OnUnderline)
	ON_BN_CLICKED(IDC_FIXED, OnFixed)
	ON_BN_CLICKED(IDC_LEFT, OnLeft)
	ON_BN_CLICKED(IDC_RIGHT, OnRight)
	ON_BN_CLICKED(IDC_VARIABLE, OnVariable)
ON_EN_CHANGE(IDC_SPACING, OnEnChangeSpacing)
ON_WM_PAINT()
END_MESSAGE_MAP()


// CFormatDlg message handlers

BOOL CFormatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	GetDlgItem(IDC_SAMPLE)->GetWindowRect(&m_RectSample);
	ScreenToClient(&m_RectSample);

	m_SpacingEdit.LimitText(1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFormatDlg::OnCenter()
{
	// TODO: Add your control notification handler code here
	if(IsDlgButtonChecked(IDC_CENTER))
	{
		m_Justify = JUSTIFY_CENTER;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnBold()
{
	// TODO: Add your control notification handler code here
	m_Bold = !m_Bold;
    InvalidateRect(&m_RectSample);
	UpdateWindow();
}

void CFormatDlg::OnItalic()
{
	// TODO: Add your control notification handler code here
	m_Italic = !m_Italic;
    InvalidateRect(&m_RectSample);
	UpdateWindow();
}

void CFormatDlg::OnUnderline()
{
	// TODO: Add your control notification handler code here
	m_Underline = !m_Underline;
    InvalidateRect(&m_RectSample);
	UpdateWindow();
}

void CFormatDlg::OnFixed()
{
	// TODO: Add your control notification handler code here
	if(IsDlgButtonChecked(IDC_FIXED))
	{
		m_Pitch = PITCH_FIXED;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnLeft()
{
	// TODO: Add your control notification handler code here
	if(IsDlgButtonChecked(IDC_LEFT))
	{
		m_Justify = JUSTIFY_LEFT;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnRight()
{
	// TODO: Add your control notification handler code here
	if(IsDlgButtonChecked(IDC_RIGHT))
	{
		m_Justify = JUSTIFY_RIGHT;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnVariable()
{
	// TODO: Add your control notification handler code here
	if(IsDlgButtonChecked(IDC_VARIABLE))
	{
		m_Justify = PITCH_VARIABLE;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnEnChangeSpacing()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	int Temp;
	Temp = (int) GetDlgItemInt(IDC_SPACING);
	if(Temp > 0 && Temp < 4)
	{
		m_Spacing = Temp;
	    InvalidateRect(&m_RectSample);
		UpdateWindow();
	}
}

void CFormatDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
   CFont Font;
   LOGFONT LF;
   int LineHeight;
   CFont *PtrOldFont;
   int X, Y;

   //   LF    :
   CFont TempFont;
   if (m_Pitch == PITCH_VARIABLE)  
      TempFont.CreateStockObject (SYSTEM_FONT);//     -
   else
      TempFont.CreateStockObject (SYSTEM_FIXED_FONT);
   TempFont.GetObject (sizeof (LOGFONT), &LF);

   //   lfWeight, lfItalic 
   if (m_Bold)
      LF.lfWeight = FW_BOLD;
   if (m_Italic)
      LF.lfItalic = 1;
   if (m_Underline)
      LF.lfUnderline = 1;

   //   :
   Font.CreateFontIndirect (&LF);
   PtrOldFont = dc.SelectObject (&Font);

  	   //  :
   switch (m_Justify)
      {
      case JUSTIFY_LEFT:
         dc.SetTextAlign (TA_LEFT);
         X = m_RectSample.left + 5;      
         break;
      case JUSTIFY_CENTER:
         dc.SetTextAlign (TA_CENTER);
         X = (m_RectSample.left + m_RectSample.right) / 2;
         break;
      case JUSTIFY_RIGHT:
         dc.SetTextAlign (TA_RIGHT);
         X = m_RectSample.right - 5;      
         break;         
      }

   //    :
   dc.SetBkMode (TRANSPARENT);

   	   //   :
   LineHeight = LF.lfHeight * m_Spacing;
   Y = m_RectSample.top + 15;
   dc.TextOut (X, Y, "AaBbCdDdEeFf");
   Y += LineHeight;
   dc.TextOut (X, Y, "GhHhIiJjKkLl");
   Y += LineHeight;
   dc.TextOut (X, Y, "MmNnOoPpQqRr");

   //    :
   dc.SelectObject (PtrOldFont);
}


