// TextDemoView.cpp : implementation of the CTextDemoView class
//

#include "stdafx.h"
#include "TextDemo.h"

#include "TextDemoDoc.h"
#include "TextDemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTextDemoView

IMPLEMENT_DYNCREATE(CTextDemoView, CScrollView)

BEGIN_MESSAGE_MAP(CTextDemoView, CScrollView)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
END_MESSAGE_MAP()

// CTextDemoView construction/destruction

CTextDemoView::CTextDemoView()
{
	// TODO: add construction code here

}

CTextDemoView::~CTextDemoView()
{
}

BOOL CTextDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

// CTextDemoView drawing

void CTextDemoView::OnDraw(CDC* pDC)
{
	CTextDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	RECT ClipRect;
	int LineHeight;
	TEXTMETRIC TM;
	int Y = MARGIN;
	//       
	if (pDoc->flag==2)
	{
	//   GDI
		HGDIOBJ m_hObject = ::GetStockObject(pDoc->m_IndexStdFont);
	//    ,    
		if (m_hObject == NULL)
			  return;  
	//        
		pDC->SelectStockObject(pDoc->m_IndexStdFont);
	//   
		pDC->TextOut (MARGIN, Y,pDoc->m_Text);
	}
	//      
	else if (pDoc->flag==1)
	{
  	// ,      :
	   if (pDoc->m_Font.m_hObject == NULL)
	      return;                         
	 
//      :                                           
	   pDC->SelectObject (&pDoc->m_Font); 
	
//  
	   pDC->GetTextMetrics(&TM);
	   LineHeight = TM.tmHeight + TM.tmExternalLeading;
//   :
	   pDC->SetTextColor (pDoc->m_Color);
	   pDC->SetBkMode (TRANSPARENT);
	      
//   ,  :
	  pDC->GetClipBox (&ClipRect);
//   :                                          
	   pDC->TextOut (MARGIN, Y,"FONT PROPERTIES");
	   
	   //   :
	   for (int Line = 0; Line < NUMLINES; ++Line)
	      {
			Y += LineHeight;
			if (Y + LineHeight >= ClipRect.top && Y <= ClipRect.bottom)
				 pDC->TextOut (MARGIN, Y, pDoc->m_LineTable [Line]);
	      }   
	}
}
//   OnUpdate() 
//void CTextDemoView::OnInitialUpdate()
//{
//	CScrollView::OnInitialUpdate();
//	CSize sizeTotal;
//	// TODO: calculate the total size of this view
//	sizeTotal.cx = sizeTotal.cy = 100;
//	SetScrollSizes(MM_TEXT, sizeTotal);
//}


// CTextDemoView diagnostics

#ifdef _DEBUG
void CTextDemoView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTextDemoView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTextDemoDoc* CTextDemoView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTextDemoDoc)));
	return (CTextDemoDoc*)m_pDocument;
}
#endif //_DEBUG


// CTextDemoView message handlers

void CTextDemoView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: Add your specialized code here and/or call the base class
   CTextDemoDoc* pDoc = GetDocument();
   if (pDoc->m_Font.m_hObject == NULL) 
      SetScrollSizes (MM_TEXT, CSize (0,0)); 
   else                                
      {
   	  CClientDC ClientDC (this); 
      int LineWidth = 0; // 
      SIZE SizeTotal; //    
      TEXTMETRIC TM; // 
	//      
      ClientDC.SelectObject (&pDoc->m_Font); 
      ClientDC.GetTextMetrics (&TM); //  
	//       
      for (int Line = 0; Line < NUMLINES; ++Line) 
         {
		//        
         SizeTotal = ClientDC.GetTextExtent(
			     pDoc->m_LineTable [Line], //  
                 pDoc->m_LineTable [Line].GetLength ()  // 
				 );
         if (SizeTotal.cx > LineWidth) //    ()
            LineWidth = SizeTotal.cx; 
         }   
      //      
      SizeTotal.cx = LineWidth + MARGIN; 
	  //      
      SizeTotal.cy = (TM.tmHeight + TM.tmExternalLeading) * (NUMLINES + 1) + MARGIN; 
      //    
      SetScrollSizes (MM_TEXT, SizeTotal); 
	  //       
      ScrollToPosition (CPoint (0, 0)); 
      }  
   CScrollView::OnUpdate (pSender, lHint, pHint);  
}

void CTextDemoView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
   CSize DocSize = GetTotalSize ();
   RECT ClientRect;
   GetClientRect (&ClientRect);

   switch (nChar)
      {  
      case VK_LEFT:     // left arrow
         if (ClientRect.right < DocSize.cx)
            SendMessage (WM_HSCROLL, SB_LINELEFT);
         break;
         
      case VK_RIGHT:    // right arrow
         if (ClientRect.right < DocSize.cx)
            SendMessage (WM_HSCROLL, SB_LINERIGHT);
         break;
                     
      case VK_UP:       // up arrow
         if (ClientRect.bottom < DocSize.cy)
            SendMessage (WM_VSCROLL, SB_LINEUP);           
         break;
         
      case VK_DOWN:     // down arrow
         if (ClientRect.bottom < DocSize.cy)
            SendMessage (WM_VSCROLL, SB_LINEDOWN);           
         break;
		 
	  case VK_HOME:     // Home key
         if (::GetKeyState (VK_CONTROL) & 0x8000)  // Ctrl pressed
            {
            if (ClientRect.bottom < DocSize.cy)
               SendMessage (WM_VSCROLL, SB_TOP);
            }
         else                                      // Home key alone
            {                                    
            if (ClientRect.right < DocSize.cx)
               SendMessage (WM_HSCROLL, SB_LEFT);
            }    
         break;   
            
      case VK_END:      // End key
         if (::GetKeyState (VK_CONTROL) & 0x8000)  // Ctrl pressed
            {
            if (ClientRect.bottom < DocSize.cy)
               SendMessage (WM_VSCROLL, SB_BOTTOM);
            }
         else                                      // End key alone
            {                                    
            if (ClientRect.right < DocSize.cx)
               SendMessage (WM_HSCROLL, SB_RIGHT);
            }    
         break;   

      case VK_PRIOR:    // PgUp key                      
         if (ClientRect.bottom < DocSize.cy)
            SendMessage (WM_VSCROLL, SB_PAGEUP);           
         break;
         
      case VK_NEXT:     // PgDn key                      
         if (ClientRect.bottom < DocSize.cy)
            SendMessage (WM_VSCROLL, SB_PAGEDOWN);           
         break;
	  }

  CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}


