// MandelView.cpp : implementation of the CMandelView class
//

#include "stdafx.h"
#include "Mandel.h"

#include "MandelDoc.h"
#include "MandelView.h"
#define CImMAX 1.25 //     
                   // 
#define CImMIN -1.25 //     
                   // 
#define CReMAX 1.25 //     
#define CReMIN -2.0 //     
#define MAX_ITERATION 128 // 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
DWORD ColorTable [6] =
    {0x0000ff,  // RGB(255,0,0)
     0x00ff00,  // RGB(0,255,0)
     0xff0000,  //  RGB(0,0,255)
     0x00ffff,  //  RGB(255,255,0)
     0xffff00,  //  RGB(0,255,255)
     0xff00ff,   //  RGB(255,0,255)
	}; 


// CMandelView

IMPLEMENT_DYNCREATE(CMandelView, CView)

BEGIN_MESSAGE_MAP(CMandelView, CView)
	ON_WM_SIZE() 
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP()

// CMandelView construction/destruction

CMandelView::CMandelView(): 
//m_Col(0)   //  OnDraw()
 m_ColMax(0)
//, m_CRe(0)   //  OnDraw()
, m_DCRe(0)
, m_DCIm(0)
, m_RowMax(0)  
//, m_CIm(0)  //  DrawCol()

{
	// TODO: add construction code here

}

CMandelView::~CMandelView()
{
}

BOOL CMandelView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CMandelView drawing

void CMandelView::OnDraw(CDC* /*pDC*/)
{
	CMandelDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	m_Col = 0;
    m_CRe = CReMIN;
	

}


// CMandelView diagnostics

#ifdef _DEBUG
void CMandelView::AssertValid() const
{
	CView::AssertValid();
}

void CMandelView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMandelDoc* CMandelView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMandelDoc)));
	return (CMandelDoc*)m_pDocument;
}
#endif //_DEBUG


// CMandelView message handlers
void CMandelView::OnSize(UINT nType, int cx, int cy)
{
   CView::OnSize(nType, cx, cy);
   
 // TODO: Add your message handler code here
   if (cx <=1 || cy <= 1)  //   
           return;
   m_ColMax = cx;
   m_RowMax = cy;
   m_DCRe = (CReMAX - CReMIN) / (m_ColMax-1);
   m_DCIm = (CImMAX - CImMIN) / (m_RowMax-1);
}
void CMandelView::DrawCol(void)
{
	
   CClientDC ClientDC (this);
   int Iteration; //  
   float Im;      //     
   float ImSqr;   //    
   float ReSqr;   //    
                  //
   float Re;      //    
                  //
   int Row;       //   -    
                  // 
//      ,  
   if (m_Col >= m_ColMax || GetParentFrame ()->IsIconic ())
     return;
   m_CIm = CImMAX;  //     
                    //
   for (Row = 0; Row < m_RowMax; ++Row) //   
      {
      Re =0.0;
      Im = 0.0;
      ReSqr = 0.0;
      ImSqr = 0.0;
      Iteration = 0;
	  
//          
// 2
      while (Iteration < MAX_ITERATION && ReSqr + ImSqr < 4)
        {
         ++Iteration;      //   
         ReSqr = Re * Re;  //   
                           //  
         ImSqr = Im * Im;
         Im = 2 * Im * Re + m_CIm;
         Re = ReSqr - ImSqr + m_CRe;
		}
                           //   
      ClientDC.SetPixelV (m_Col, Row, ColorTable [Iteration % 6]);
      m_CIm -= m_DCIm; //    
                       //
      }
   m_Col++;         //   
   m_CRe += m_DCRe; //   
                    //
}




