// MiniPaint.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MiniPaint.h"
#include "MainFrm.h"

#include "MiniPaintDoc.h"
#include "MiniPaintView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiniPaintApp

BEGIN_MESSAGE_MAP(CMiniPaintApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_LINES_DOUBLE, OnLinesDouble)
	ON_UPDATE_COMMAND_UI(ID_LINES_DOUBLE, OnUpdateLinesDouble)
	ON_COMMAND(ID_LINES_SINGLE, OnLinesSingle)
	ON_UPDATE_COMMAND_UI(ID_LINES_SINGLE, OnUpdateLinesSingle)
	ON_COMMAND(ID_LINES_TRIPLE, OnLinesTriple)
	ON_UPDATE_COMMAND_UI(ID_LINES_TRIPLE, OnUpdateLinesTriple)
	ON_COMMAND(ID_TOOLS_CIRCLE, OnToolsCircle)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_CIRCLE, OnUpdateToolsCircle)
	ON_COMMAND(ID_TOOLS_CIRCLEFILL, OnToolsCirclefill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_CIRCLEFILL, OnUpdateToolsCirclefill)
	ON_COMMAND(ID_TOOLS_LINE, OnToolsLine)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_LINE, OnUpdateToolsLine)
	ON_COMMAND(ID_TOOLS_RECTANGLE, OnToolsRectangle)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTANGLE, OnUpdateToolsRectangle)
	ON_COMMAND(ID_TOOLS_RECTFILL, OnToolsRectfill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTFILL, OnUpdateToolsRectfill)
	ON_COMMAND(ID_TOOLS_RECTROUND, OnToolsRectround)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTROUND, OnUpdateToolsRectround)
	ON_COMMAND(ID_TOOLS_RECTROUNDFILL, OnToolsRectroundfill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTROUNDFILL, OnUpdateToolsRectroundfill)
//	ON_COMMAND(ID_VIEW_TOOLBAR, OnViewToolbar)
//	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBAR, OnUpdateViewToolbar)
END_MESSAGE_MAP()


// CMiniPaintApp construction

CMiniPaintApp::CMiniPaintApp()
: m_CurrentThickness(1)
//, m_CurrentTool(0)
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_CurrentTool = ID_TOOLS_LINE;
}


// The one and only CMiniPaintApp object

CMiniPaintApp theApp;

// CMiniPaintApp initialization

BOOL CMiniPaintApp::InitInstance()
{
	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMiniPaintDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMiniPaintView));
	AddDocTemplate(pDocTemplate);
	 EnableShellOpen ();
 RegisterShellFileTypes ();

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
    m_pMainWnd->DragAcceptFiles ();
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CMiniPaintApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CMiniPaintApp message handlers


void CMiniPaintApp::OnLinesDouble()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 2;
}

void CMiniPaintApp::OnUpdateLinesDouble(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 2 ? 1 : 0);
}

void CMiniPaintApp::OnLinesSingle()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 1;
}

void CMiniPaintApp::OnUpdateLinesSingle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 1 ? 1 : 0);
}

void CMiniPaintApp::OnLinesTriple()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 3;
}

void CMiniPaintApp::OnUpdateLinesTriple(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 3 ? 1 : 0);
}

void CMiniPaintApp::OnToolsCircle()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_CIRCLE;
}

void CMiniPaintApp::OnUpdateToolsCircle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_CIRCLE ? 1 : 0);
}

void CMiniPaintApp::OnToolsCirclefill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_CIRCLEFILL;
}

void CMiniPaintApp::OnUpdateToolsCirclefill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_CIRCLEFILL ? 1 : 0);
}

void CMiniPaintApp::OnToolsLine()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_LINE;
}

void CMiniPaintApp::OnUpdateToolsLine(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_LINE ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectangle()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTANGLE;
}

void CMiniPaintApp::OnUpdateToolsRectangle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTANGLE ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectfill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTFILL;

}

void CMiniPaintApp::OnUpdateToolsRectfill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTFILL ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectround()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTROUND;
}

void CMiniPaintApp::OnUpdateToolsRectround(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTROUND ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectroundfill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTROUNDFILL;
}

void CMiniPaintApp::OnUpdateToolsRectroundfill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTROUNDFILL ? 1 : 0);
}

//void CMiniPaintApp::OnViewToolbar()
//{
//	// TODO: Add your command handler code here
//}

//void CMiniPaintApp::OnUpdateViewToolbar(CCmdUI *pCmdUI)
//{
//	// TODO: Add your command update UI handler code here
//}
