// MiniPaintView.cpp : implementation of the CMiniPaintView class
//


#include "stdafx.h"
#include "MiniPaint.h"

#include "MiniPaintDoc.h"
#include "MiniPaintView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiniPaintView

IMPLEMENT_DYNCREATE(CMiniPaintView, CScrollView)

BEGIN_MESSAGE_MAP(CMiniPaintView, CScrollView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CMiniPaintView construction/destruction

CMiniPaintView::CMiniPaintView()
: m_Dragging(0)
, m_PointOld(0)
, m_PointOrigin(0)
, m_ClassName(_T(""))
{
	// TODO: add construction code here
m_HCross = AfxGetApp ()->LoadStandardCursor (IDC_CROSS); 
///////////////////////////
m_HArrow = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
//////////////////////
}

CMiniPaintView::~CMiniPaintView()
{
}

BOOL CMiniPaintView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
   m_ClassName = AfxRegisterWndClass
	  (CS_HREDRAW | CS_VREDRAW,             //  
	  0,				       //  
	  (HBRUSH):: GetStockObject (WHITE_BRUSH),
				      //     
	  0);           //   
	cs.lpszClass = m_ClassName;
	return CScrollView::PreCreateWindow(cs);
}

// CMiniPaintView drawing

void CMiniPaintView::OnDraw(CDC* pDC)
{
	CMiniPaintDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	/////////////////////////
	CSize ScrollSize = GetTotalSize();
	pDC->MoveTo(ScrollSize.cx, 0);
	pDC->LineTo(ScrollSize.cx, ScrollSize.cy);
	pDC->LineTo(0, ScrollSize.cy);
	////////////////////////

	int Index = pDoc->GetNumLines ();
   while (Index--)
   {	pDoc->GetLine(Index)->Draw(pDC);
              
   }
}



// CMiniPaintView diagnostics

#ifdef _DEBUG
void CMiniPaintView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMiniPaintView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMiniPaintDoc* CMiniPaintView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMiniPaintDoc)));
	return (CMiniPaintDoc*)m_pDocument;
}
#endif //_DEBUG


// CMiniPaintView message handlers

void CMiniPaintView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CClientDC ClientDC (this);
	OnPrepareDC (&ClientDC);
	ClientDC.DPtoLP (&point);
	////////////////////////////////
	
	CSize ScrollSize = GetTotalSize();
	CRect ScrollRect(0, 0, ScrollSize.cx, ScrollSize.cy);
	if(!ScrollRect.PtInRect(point))
		return;
	//////////////////////////
     m_PointOrigin = point;
     m_PointOld = point;
     SetCapture ();
     m_Dragging = 1;
	 ///////////////////////////////
	 ClientDC.LPtoDP(&ScrollRect);
	CRect ViewRect;
	GetClientRect(&ViewRect);
	CRect IntRect;
	IntRect.IntersectRect(&ScrollRect, &ViewRect);

	ClientToScreen(&IntRect);
	::ClipCursor(&IntRect);
	 //////////////////////////////
     //RECT Rect;
     //GetClientRect (&Rect);
     //ClientToScreen (&Rect);
     //::ClipCursor (&Rect);
     

	CScrollView::OnLButtonDown(nFlags, point);
}

void CMiniPaintView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
if (m_Dragging)
    {
    m_Dragging = 0;
    ::ReleaseCapture ();
    ::ClipCursor (NULL);
    CClientDC ClientDC (this);
	///////////////////////
	OnPrepareDC (&ClientDC);
	ClientDC.DPtoLP (&point);
	/////////////////////
    ClientDC.SetROP2 (R2_NOT);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (m_PointOld);
    ClientDC.SetROP2 (R2_COPYPEN);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (point);
	//////////////////
	CMiniPaintDoc* PDoc = GetDocument();
   //  PDoc->AddLine (m_PointOrigin.x, m_PointOrigin.y, point.x,point.y);
   //PDoc->UpdateAllViews(this);
        CLine* PCLine;
		PCLine = PDoc->AddLine(m_PointOrigin.x,m_PointOrigin.y,point.x,point.y);
		PDoc->UpdateAllViews(this, 0, PCLine);  
	}
	CScrollView::OnLButtonUp(nFlags, point);
}


void CMiniPaintView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CClientDC ClientDC(this);
	OnPrepareDC (&ClientDC);
	ClientDC.DPtoLP(&point);

	CSize ScrollSize = GetTotalSize();
	CRect ScrollRect(0, 0, ScrollSize.cx, ScrollSize.cy);
	if(ScrollRect.PtInRect(point))
		::SetCursor(m_HCross);
	else
		::SetCursor(m_HArrow);
 //::SetCursor (m_HCross);
 if (m_Dragging)
    {
   // CClientDC ClientDC (this);
	//OnPrepareDC (&ClientDC);
	//ClientDC.DPtoLP (&point);

	ClientDC.SetROP2 (R2_NOT);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (m_PointOld);
    ClientDC.MoveTo (m_PointOrigin);
    ClientDC.LineTo (point);
    m_PointOld = point;
    }
	CScrollView::OnMouseMove(nFlags, point);
}

void CMiniPaintView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	//SIZE Size = {640, 480};
	SIZE Size = {300, 300};
	SetScrollSizes (MM_TEXT, Size);
}

void CMiniPaintView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pHint != 0)
	{
		CRect InvalidRect = ((CLine*)pHint)->GetDimRect();
		CClientDC ClientDC (this);
		OnPrepareDC(&ClientDC);
		ClientDC.DPtoLP(&InvalidRect);
		InvalidateRect(&InvalidRect);
	}
	else CScrollView::OnUpdate(pSender, lHint, pHint);
}



