// MiniPaint.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MiniPaint.h"
#include "MainFrm.h"

#include "MiniPaintDoc.h"
#include "MiniPaintView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiniPaintApp

BEGIN_MESSAGE_MAP(CMiniPaintApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_LINES_DOUBLE, OnLinesDouble)
	ON_UPDATE_COMMAND_UI(ID_LINES_DOUBLE, OnUpdateLinesDouble)
	ON_COMMAND(ID_LINES_SINGLE, OnLinesSingle)
	ON_UPDATE_COMMAND_UI(ID_LINES_SINGLE, OnUpdateLinesSingle)
	ON_COMMAND(ID_LINES_TRIPLE, OnLinesTriple)
	ON_UPDATE_COMMAND_UI(ID_LINES_TRIPLE, OnUpdateLinesTriple)
	ON_COMMAND(ID_TOOLS_CIRCLE, OnToolsCircle)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_CIRCLE, OnUpdateToolsCircle)
	ON_COMMAND(ID_TOOLS_CIRCLEFILL, OnToolsCirclefill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_CIRCLEFILL, OnUpdateToolsCirclefill)
	ON_COMMAND(ID_TOOLS_LINE, OnToolsLine)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_LINE, OnUpdateToolsLine)
	ON_COMMAND(ID_TOOLS_RECTANGLE, OnToolsRectangle)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTANGLE, OnUpdateToolsRectangle)
	ON_COMMAND(ID_TOOLS_RECTFILL, OnToolsRectfill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTFILL, OnUpdateToolsRectfill)
	ON_COMMAND(ID_TOOLS_RECTROUND, OnToolsRectround)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTROUND, OnUpdateToolsRectround)
	ON_COMMAND(ID_TOOLS_RECTROUNDFILL, OnToolsRectroundfill)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RECTROUNDFILL, OnUpdateToolsRectroundfill)
	ON_COMMAND(ID_COLOR_BLACK, OnColorBlack)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLACK, OnUpdateColorBlack)
	ON_COMMAND(ID_COLOR_RED, OnColorRed)
	ON_UPDATE_COMMAND_UI(ID_COLOR_RED, OnUpdateColorRed)
	ON_COMMAND(ID_COLOR_GREEN, OnColorGreen)
	ON_UPDATE_COMMAND_UI(ID_COLOR_GREEN, OnUpdateColorGreen)
	ON_COMMAND(ID_COLOR_BLUE, OnColorBlue)
	ON_UPDATE_COMMAND_UI(ID_COLOR_BLUE, OnUpdateColorBlue)
	ON_COMMAND(ID_COLOR_CUSTOM, OnColorCustom)
	ON_UPDATE_COMMAND_UI(ID_COLOR_CUSTOM, OnUpdateColorCustom)
	ON_COMMAND(ID_COLOR_CYAN, OnColorCyan)
	ON_UPDATE_COMMAND_UI(ID_COLOR_CYAN, OnUpdateColorCyan)
	ON_COMMAND(ID_COLOR_MAGENTA, OnColorMagenta)
	ON_UPDATE_COMMAND_UI(ID_COLOR_MAGENTA, OnUpdateColorMagenta)
	ON_COMMAND(ID_COLOR_WHITE, OnColorWhite)
	ON_UPDATE_COMMAND_UI(ID_COLOR_WHITE, OnUpdateColorWhite)
	ON_COMMAND(ID_COLOR_YELLOW, OnColorYellow)
	ON_UPDATE_COMMAND_UI(ID_COLOR_YELLOW, OnUpdateColorYellow)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()


// CMiniPaintApp construction

CMiniPaintApp::CMiniPaintApp()
: m_CurrentThickness(1)
//, m_CurrentTool(0)
//, m_IdxColorCmd(0)//  
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_CurrentTool = ID_TOOLS_LINE;
	m_CurrentColor = RGB(0,0,0);
	m_IdxColorCmd = ID_COLOR_BLACK;
}


// The one and only CMiniPaintApp object

CMiniPaintApp theApp;

// CMiniPaintApp initialization

BOOL CMiniPaintApp::InitInstance()
{
	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMiniPaintDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CMiniPaintView));
	AddDocTemplate(pDocTemplate);
	 EnableShellOpen ();
 RegisterShellFileTypes ();

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
    m_pMainWnd->DragAcceptFiles ();
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CMiniPaintApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CMiniPaintApp message handlers


void CMiniPaintApp::OnLinesDouble()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 2;
}

void CMiniPaintApp::OnUpdateLinesDouble(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 2 ? 1 : 0);
}

void CMiniPaintApp::OnLinesSingle()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 1;
}

void CMiniPaintApp::OnUpdateLinesSingle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 1 ? 1 : 0);
}

void CMiniPaintApp::OnLinesTriple()
{
	// TODO: Add your command handler code here
	m_CurrentThickness = 3;
}

void CMiniPaintApp::OnUpdateLinesTriple(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentThickness == 3 ? 1 : 0);
}

void CMiniPaintApp::OnToolsCircle()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_CIRCLE;
}

void CMiniPaintApp::OnUpdateToolsCircle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_CIRCLE ? 1 : 0);
}

void CMiniPaintApp::OnToolsCirclefill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_CIRCLEFILL;
}

void CMiniPaintApp::OnUpdateToolsCirclefill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_CIRCLEFILL ? 1 : 0);
}

void CMiniPaintApp::OnToolsLine()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_LINE;
}

void CMiniPaintApp::OnUpdateToolsLine(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_LINE ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectangle()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTANGLE;
}

void CMiniPaintApp::OnUpdateToolsRectangle(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTANGLE ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectfill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTFILL;

}

void CMiniPaintApp::OnUpdateToolsRectfill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTFILL ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectround()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTROUND;
}

void CMiniPaintApp::OnUpdateToolsRectround(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTROUND ? 1 : 0);
}

void CMiniPaintApp::OnToolsRectroundfill()
{
	// TODO: Add your command handler code here
	m_CurrentTool = ID_TOOLS_RECTROUNDFILL;
}

void CMiniPaintApp::OnUpdateToolsRectroundfill(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_CurrentTool == ID_TOOLS_RECTROUNDFILL ? 1 : 0);
}

//void CMiniPaintApp::OnViewToolbar()
//{
//	// TODO: Add your command handler code here
//}

//void CMiniPaintApp::OnUpdateViewToolbar(CCmdUI *pCmdUI)
//{
//	// TODO: Add your command update UI handler code here
//}

void CMiniPaintApp::OnColorBlack()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(0,0,0);
	m_IdxColorCmd = ID_COLOR_BLACK;
}

void CMiniPaintApp::OnUpdateColorBlack(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_BLACK ? 1 : 0);
}

void CMiniPaintApp::OnColorRed()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(255,0,0);
	m_IdxColorCmd = ID_COLOR_RED;
}

void CMiniPaintApp::OnUpdateColorRed(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_RED ? 1 : 0);
}


void CMiniPaintApp::OnColorGreen()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(0,255,0);
	m_IdxColorCmd = ID_COLOR_GREEN;
}

void CMiniPaintApp::OnUpdateColorGreen(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_GREEN ? 1 : 0);
}
void CMiniPaintApp::OnColorBlue()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(0,0,255);
	m_IdxColorCmd = ID_COLOR_BLUE;
}

void CMiniPaintApp::OnUpdateColorBlue(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_BLUE ? 1 : 0);
}

void CMiniPaintApp::OnColorCustom()
{
	// TODO: Add your command handler code here
	CColorDialog ColorDialog;

	if(ColorDialog.DoModal() == IDOK)
	{
		m_CurrentColor = ColorDialog.GetColor();
		m_IdxColorCmd = ID_COLOR_CUSTOM;
	}
}

void CMiniPaintApp::OnUpdateColorCustom(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_CUSTOM ? 1 : 0);
}

void CMiniPaintApp::OnColorCyan()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(0,255,255);
	m_IdxColorCmd = ID_COLOR_CYAN;
}

void CMiniPaintApp::OnUpdateColorCyan(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_CYAN ? 1 : 0);
}


void CMiniPaintApp::OnColorMagenta()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(255,0,255);
	m_IdxColorCmd = ID_COLOR_MAGENTA;
}

void CMiniPaintApp::OnUpdateColorMagenta(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_MAGENTA ? 1 : 0);
}


void CMiniPaintApp::OnColorWhite()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(255,255,255);
	m_IdxColorCmd = ID_COLOR_WHITE;
}

void CMiniPaintApp::OnUpdateColorWhite(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_WHITE ? 1 : 0);
}

void CMiniPaintApp::OnColorYellow()
{
	// TODO: Add your command handler code here
	m_CurrentColor = RGB(255,255,0);
	m_IdxColorCmd = ID_COLOR_YELLOW;
}

void CMiniPaintApp::OnUpdateColorYellow(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_IdxColorCmd == ID_COLOR_YELLOW ? 1 : 0);
}

