//   MiniPaintDoc.cpp : implementation of the CMiniPaintDoc class
//

#include "stdafx.h"
#include "MiniPaint.h"

#include "MiniPaintDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

////////////////////////////////////
// CMiniPaintDoc

IMPLEMENT_DYNCREATE(CMiniPaintDoc, CDocument)

BEGIN_MESSAGE_MAP(CMiniPaintDoc, CDocument)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, OnEditClearAll)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR_ALL, OnUpdateEditClearAll)
END_MESSAGE_MAP()


// CMiniPaintDoc construction/destruction

CMiniPaintDoc::CMiniPaintDoc()
{
	// TODO: add one-time construction code here
}

CMiniPaintDoc::~CMiniPaintDoc()
{
}

BOOL CMiniPaintDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	return TRUE;
}

// CMiniPaintDoc serialization

void CMiniPaintDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		m_FigureArray.Serialize (ar);
	}
	else
	{
		// TODO: add loading code here
		m_FigureArray.Serialize (ar);
	}
}


// CMiniPaintDoc diagnostics

#ifdef _DEBUG
void CMiniPaintDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMiniPaintDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

void CMiniPaintDoc::DeleteContents()
{
// TODO: Add your specialized code here and/or call the base class
  int Index = m_FigureArray.GetSize();
  while (Index--)
     delete m_FigureArray.GetAt(Index);
  m_FigureArray.RemoveAll();
  CDocument::DeleteContents();
}

void CMiniPaintDoc::OnEditClearAll()
{
	DeleteContents (); 
   UpdateAllViews (0); 

	// TODO: Add your command handler code here
    SetModifiedFlag ( );
}

void CMiniPaintDoc::OnEditUndo()
{
	// TODO: Add your command handler code here
	int Index = m_FigureArray.GetUpperBound ();
	if (Index > -1)
	{
		delete m_FigureArray.GetAt (Index);
		m_FigureArray.RemoveAt (Index); 
	}
	UpdateAllViews (0);
	SetModifiedFlag (); 
}

void CMiniPaintDoc::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (m_FigureArray.GetSize ());
}

void CMiniPaintDoc::OnUpdateEditClearAll(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here  
	pCmdUI->Enable (m_FigureArray.GetSize ());

}
//     CFigure   
void CMiniPaintDoc::AddFigure(CFigure* pFigure)
{
	m_FigureArray.Add(pFigure);
	SetModifiedFlag();
}

//     CFigure
CFigure* CMiniPaintDoc::GetFigure(int IndexFigure)
{
	if (IndexFigure < 0 || IndexFigure > m_FigureArray.GetUpperBound())
		return 0;
	return (CFigure*)m_FigureArray.GetAt(IndexFigure);
}

//    
int CMiniPaintDoc::GetNumFigures(void)
{
	return m_FigureArray.GetSize();
}


//////////////////////////////////////////
//    
//#include "stdafx.h"
//#include "MiniPaint.h"
//#include "C:\VCNET\Tut11\MiniPaint\MiniPaintDoc.h"
//#include "D:\VCNET\Tut11\MiniPaint_m\MiniPaintDoc.h"

// CFigure
IMPLEMENT_SERIAL (CFigure, CObject, 3)

CFigure::CFigure()
: m_X1(0)
, m_Y1(0)
, m_X2(0)
, m_Y2(0)
{
}

CFigure::~CFigure()
{
}


//  
void CFigure::Draw(CDC* pDC)
{
}
//  
CRect CFigure::GetDimRect(void)
{
	return CRect
		(
		  min (m_X1, m_X2),
          min (m_Y1, m_Y2),
          max (m_X1, m_X2) + 1,
          max (m_Y1, m_Y2) + 1
		 );
}

//  
void CFigure::Serialize(CArchive& ar)
{
if (ar.IsStoring ())
      ar << m_X1 << m_Y1 << m_X2 << m_Y2 << m_Color;
   else
      ar >> m_X1 >> m_Y1 >> m_X2 >> m_Y2 >> m_Color;	
}


//CLine implementation
IMPLEMENT_SERIAL(CLine, CFigure, 3)

CLine::CLine (int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
   {
   m_X1 = X1;
   m_Y1 = Y1;
   m_X2 = X2;
   m_Y2 = Y2;
   m_Color = Color;
   m_Thickness = Thickness;
   }

CLine::~CLine()
{
}
void CLine::Draw (CDC *PDC)
   {
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_SOLID, m_Thickness, m_Color);
   POldPen = PDC->SelectObject (&Pen);

   // draw Line:
   PDC->MoveTo (m_X1, m_Y1);
   PDC->LineTo (m_X2, m_Y2);

   // remove pen/brush: 
   PDC->SelectObject (POldPen);
   }

// CLine member functions
CLine::CLine(void)
{
}

void CLine::Serialize (CArchive& ar)
   {
CFigure::Serialize (ar); 
	   if (ar.IsStoring ())
      ar<<m_Thickness;
   else
      ar>>m_Thickness;
   }
//////////////////////////////////////////
//CRectangle implementation
  IMPLEMENT_SERIAL(CRectangle, CFigure, 3)

CRectangle::CRectangle (int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
   {
   m_X1 = X1;
   m_Y1 = Y1;
   m_X2 = X2;
   m_Y2 = Y2;
   m_Color = Color;
   m_Thickness = Thickness;
   }

CRectangle::~CRectangle()
{
}
// 
void CRectangle::Draw (CDC *PDC)
   {
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, m_Thickness, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   PDC->SelectStockObject (NULL_BRUSH);

   // draw figure:
   PDC->Rectangle (m_X1, m_Y1, m_X2, m_Y2);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   }

CRectangle::CRectangle(void)
{
}

void CRectangle::Serialize (CArchive& ar)
   {
CFigure::Serialize (ar);

   if (ar.IsStoring ())
      ar<<m_Thickness;
   else
      ar>>m_Thickness;
   }
  //////////////////////////////////////
  //CRectRound implementation
  IMPLEMENT_SERIAL(CRectRound, CFigure, 3)

CRectRound::CRectRound (int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
   {
   m_X1 = X1;
   m_Y1 = Y1;
   m_X2 = X2;
   m_Y2 = Y2;
   m_Color = Color;
   m_Thickness = Thickness;
   }

CRectRound::~CRectRound()
{
}
// 
void CRectRound::Draw (CDC *PDC)
   {
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, m_Thickness, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   PDC->SelectStockObject (NULL_BRUSH);

   // draw figure:
   int SizeRound = (m_X2 - m_X1 + m_Y2 - m_Y1) / 6;
   PDC->RoundRect (m_X1, m_Y1, m_X2, m_Y2, SizeRound, SizeRound);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   }

CRectRound::CRectRound(void)
{
}

void CRectRound::Serialize (CArchive& ar)
   {
	CFigure::Serialize (ar);
	if (ar.IsStoring ())
      ar<<m_Thickness;
    else
      ar>>m_Thickness;
   }
///////////////////////////////////////////////
//CCircle implementation
IMPLEMENT_SERIAL(CCircle, CFigure, 3)

CCircle::CCircle (int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness)
   {
   m_X1 = X1;
   m_Y1 = Y1;
   m_X2 = X2;
   m_Y2 = Y2;
   m_Color = Color;
   m_Thickness = Thickness;
   }

CCircle::~CCircle()
{
}
// 
void CCircle::Draw (CDC *PDC)
   {
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, m_Thickness, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   PDC->SelectStockObject (NULL_BRUSH);

   // draw figure:
   PDC->Ellipse (m_X1, m_Y1, m_X2, m_Y2);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   }

CCircle::CCircle(void)
{
}

void CCircle::Serialize (CArchive& ar)
   {
CFigure::Serialize (ar);

   if (ar.IsStoring ())
      ar<<m_Thickness;
   else
      ar>>m_Thickness;
   }
//////////////////////////////////
//CRectFill implementation

IMPLEMENT_SERIAL (CRectFill, CFigure, 3)

CRectFill::CRectFill (int X1, int Y1, int X2, int Y2, COLORREF Color)
   {
   m_X1 = min (X1, X2);
   m_Y1 = min (Y1, Y2);
   m_X2 = max (X1, X2);
   m_Y2 = max (Y1, Y2);
   m_Color = Color;
   }

void CRectFill::Draw (CDC *PDC)
   {
   CBrush Brush, *POldBrush;
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, 1, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   Brush.CreateSolidBrush (m_Color);
   POldBrush = PDC->SelectObject (&Brush);

   // draw figure:
   PDC->Rectangle (m_X1, m_Y1, m_X2, m_Y2);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   PDC->SelectObject (POldBrush);
   }
//////////////////////////////////////////////////
   IMPLEMENT_SERIAL (CRectRoundFill, CFigure, 3)

CRectRoundFill::CRectRoundFill (int X1, int Y1, int X2, int Y2, COLORREF Color)
   {
   m_X1 = min (X1, X2);
   m_Y1 = min (Y1, Y2);
   m_X2 = max (X1, X2);
   m_Y2 = max (Y1, Y2);
   m_Color = Color;
   }

void CRectRoundFill::Draw (CDC *PDC)
   {
   CBrush Brush, *POldBrush;
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, 1, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   Brush.CreateSolidBrush (m_Color);
   POldBrush = PDC->SelectObject (&Brush);

   // draw figure:
   int SizeRound = (m_X2 - m_X1 + m_Y2 - m_Y1) / 6;
   PDC->RoundRect (m_X1, m_Y1, m_X2, m_Y2, SizeRound, SizeRound);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   PDC->SelectObject (POldBrush);
   }
////////////////////////////////////////////////////
   IMPLEMENT_SERIAL (CCircleFill, CFigure, 3)

CCircleFill::CCircleFill (int X1, int Y1, int X2, int Y2, COLORREF Color)
   {
   m_X1 = min (X1, X2);
   m_Y1 = min (Y1, Y2);
   m_X2 = max (X1, X2);
   m_Y2 = max (Y1, Y2);
   m_Color = Color;
   }

void CCircleFill::Draw (CDC *PDC)
   {
   CBrush Brush, *POldBrush;
   CPen Pen, *POldPen;

   // select pen/brush:
   Pen.CreatePen (PS_INSIDEFRAME, 1, m_Color);
   POldPen = PDC->SelectObject (&Pen);
   Brush.CreateSolidBrush (m_Color);
   POldBrush = PDC->SelectObject (&Brush);

   // draw figure:
   PDC->Ellipse (m_X1, m_Y1, m_X2, m_Y2);

   // remove pen/brush:  
   PDC->SelectObject (POldPen);
   PDC->SelectObject (POldBrush);
   }