// MiniPaintDoc.h : interface of the CMiniPaintDoc class
//


#pragma once
// CFigure command target

class CFigure : public CObject
{
public:
	CFigure();
	virtual ~CFigure();
protected:
	// 
	COLORREF m_Color;
	//  
	DWORD m_X1;
	DWORD m_Y1;
	DWORD m_X2;
	DWORD m_Y2;
	DECLARE_SERIAL (CFigure)
public:
	//  
	virtual void Draw(CDC* pDC);
	//  
	CRect GetDimRect(void);
	//  
	virtual void Serialize(CArchive& ar);
};
///////////////////////////////////////////
// CLine command target

class CLine : public CFigure
{
protected:
	//  
	DWORD m_Thickness;
	DECLARE_SERIAL (CLine)
public:
	
	CLine(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness);
	virtual ~CLine();
	virtual void Draw (CDC *PDC);
	CLine(void);
	virtual void Serialize(CArchive& ar);

};
///////////////////////////////////////
// CRectangle command target

class CRectangle : public CFigure
{
protected:
	//  
	DWORD m_Thickness;
	DECLARE_SERIAL (CRectangle)
public:
	
	CRectangle(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness);
	virtual ~CRectangle();
	virtual void Draw (CDC *PDC);
	CRectangle(void);
	virtual void Serialize(CArchive& ar);

};
//////////////////////////////////
class CRectRound : public CFigure
{
protected:
	//  
	DWORD m_Thickness;
	DECLARE_SERIAL (CRectRound)
public:
	
	CRectRound(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness);
	virtual ~CRectRound();
	virtual void Draw (CDC *PDC);
	CRectRound(void);
	virtual void Serialize(CArchive& ar);

};
//////////////////////////////////////////
// CCircle command target

class CCircle : public CFigure
{
protected:
	//  
	DWORD m_Thickness;
	DECLARE_SERIAL (CCircle)
public:
	
	CCircle(int X1, int Y1, int X2, int Y2, COLORREF Color, int Thickness);
	virtual ~CCircle();
	virtual void Draw (CDC *PDC);
	CCircle(void);
	virtual void Serialize(CArchive& ar);

};
/////////////////////////////
// CRectFill command target
class CRectFill : public CFigure
{
protected:
   CRectFill () {}
   DECLARE_SERIAL (CRectFill)

public:
   CRectFill (int X1, int Y1, int X2, int Y2, COLORREF Color);
   virtual void Draw (CDC *PDC);
};
//////////////////////////////////
// CRectRoundFill command target

class CRectRoundFill : public CFigure
{
protected:
   CRectRoundFill () {}
   DECLARE_SERIAL (CRectRoundFill)

public:
   CRectRoundFill (int X1, int Y1, int X2, int Y2, COLORREF Color);
   virtual void Draw (CDC *PDC);
};
/////////////////////////////////
// CCircleFill command target

class CCircleFill : public CFigure
{
protected:
   CCircleFill () {}
   DECLARE_SERIAL (CCircleFill)

public:
   CCircleFill (int X1, int Y1, int X2, int Y2, COLORREF Color);
   virtual void Draw (CDC *PDC);
};

///////////////////////////////////
class CMiniPaintDoc : public CDocument
{
protected: // create from serialization only
	CMiniPaintDoc();
	DECLARE_DYNCREATE(CMiniPaintDoc)

// Attributes
public:

// Operations
public:

// Overrides
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CMiniPaintDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
	CTypedPtrArray<CObArray, CFigure*> m_FigureArray;
public:
	virtual void DeleteContents();

	afx_msg void OnEditClearAll();
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditClearAll(CCmdUI *pCmdUI);
	//     CFigure   
	void AddFigure(CFigure* pFigure);
	//     CFigure
	CFigure* GetFigure(int IndexFigure);
	//    
	int GetNumFigures(void);
};















