// MiniPaintView.cpp : implementation of the CMiniPaintView class
//


#include "stdafx.h"
#include "MiniPaint.h"

#include "MiniPaintDoc.h"
#include "MiniPaintView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiniPaintView

IMPLEMENT_DYNCREATE(CMiniPaintView, CScrollView)

BEGIN_MESSAGE_MAP(CMiniPaintView, CScrollView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND( ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CMiniPaintView construction/destruction

CMiniPaintView::CMiniPaintView()
: m_Dragging(0)
, m_PointOld(0)
, m_PointOrigin(0)
, m_ClassName(_T(""))
, m_NumCols(0)
{
	// TODO: add construction code here
m_HCross = AfxGetApp ()->LoadStandardCursor (IDC_CROSS); 
m_HArrow = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
m_PenDotted.CreatePen(PS_DOT, 1, RGB(0,0,0));
}

CMiniPaintView::~CMiniPaintView()
{
}

BOOL CMiniPaintView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
   m_ClassName = AfxRegisterWndClass
	  (CS_HREDRAW | CS_VREDRAW,             //  
	  0,				       //  
	  (HBRUSH):: GetStockObject (WHITE_BRUSH),
				      //     
	  0);           //   
	cs.lpszClass = m_ClassName;
	return CScrollView::PreCreateWindow(cs);
}

// CMiniPaintView drawing

void CMiniPaintView::OnDraw (CDC* pDC)
{
  CMiniPaintDoc* pDoc = GetDocument ();
  ASSERT_VALID(pDoc);
  // TODO: add draw code for native data here
  if(pDC->GetDeviceCaps(TECHNOLOGY) == DT_RASDISPLAY)//   
	{
  CSize ScrollSize = GetTotalSize ();
  pDC->MoveTo(ScrollSize.cx, 0);
  pDC->LineTo(ScrollSize.cx, ScrollSize.cy);
  pDC->LineTo(0, ScrollSize.cy);
	}
  ////////////////////////
  CRect ClipRect; //  
  CRect DimRect;  //,   
  CRect IntRect;  //    
                  // 
  CFigure* PFigure;   //   
  pDC->GetClipBox (&ClipRect); 
  int NumFigures=pDoc->GetNumFigures(); //  
  for(int Index=0;Index<NumFigures;++Index) //  
   {
     PFigure = pDoc->GetFigure(Index);  //  
     DimRect = PFigure->GetDimRect();//  
     if (IntRect.IntersectRect(DimRect, ClipRect)) //      
          PFigure->Draw(pDC);  // 
   }
}

// CMiniPaintView diagnostics

#ifdef _DEBUG
void CMiniPaintView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMiniPaintView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMiniPaintDoc* CMiniPaintView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMiniPaintDoc)));
	return (CMiniPaintDoc*)m_pDocument;
}
#endif //_DEBUG


// CMiniPaintView message handlers

void CMiniPaintView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	CClientDC ClientDC (this);  //   
	OnPrepareDC (&ClientDC);
	ClientDC.DPtoLP (&point);
	////////////////////////////////
	
	CSize ScrollSize = GetTotalSize();//  
	CRect ScrollRect(0, 0, ScrollSize.cx, ScrollSize.cy); 
	if(!ScrollRect.PtInRect(point))
		return;
	//////////////////////////
     m_PointOrigin = point;
     m_PointOld = point;
     SetCapture ();
     m_Dragging = 1;
	 ///////////////////////////////
	 ClientDC.LPtoDP(&ScrollRect);
	 CRect ViewRect;
	 GetClientRect(&ViewRect);
	 CRect IntRect;
	 IntRect.IntersectRect(&ScrollRect, &ViewRect);
	 ClientToScreen(&IntRect);
	 ::ClipCursor(&IntRect);
	 CScrollView::OnLButtonDown(nFlags, point);
}
///////////////////////////////////////////////////////////////////
void CMiniPaintView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	
	CClientDC ClientDC(this);//  
	OnPrepareDC (&ClientDC);//  DC
	ClientDC.DPtoLP(&point);//        GDI

	if (!m_Dragging)
      {
      CSize ScrollSize = GetTotalSize ();//  
      CRect ScrollRect (0, 0, ScrollSize.cx, ScrollSize.cy); //  
      if (ScrollRect.PtInRect (point))//    
         ::SetCursor (m_HCross);  //      +
      else
         ::SetCursor (m_HArrow); //           
      return;
      }
   ClientDC.SetROP2 (R2_NOT);//  
   ClientDC.SelectObject (&m_PenDotted);// 
   ClientDC.SetBkMode (TRANSPARENT);//  
   ClientDC.SelectStockObject (NULL_BRUSH);//   - 

   switch (((CMiniPaintApp *)AfxGetApp ())->m_CurrentTool)
      {
      case ID_TOOLS_LINE:
         ClientDC.MoveTo (m_PointOrigin);
         ClientDC.LineTo (m_PointOld);
         ClientDC.MoveTo (m_PointOrigin);
         ClientDC.LineTo (point);
         break;

      case ID_TOOLS_RECTANGLE:
	  case ID_TOOLS_RECTFILL:
   //              
		  ClientDC.Rectangle (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y);
  
	      ClientDC.Rectangle (m_PointOrigin.x, m_PointOrigin.y,
                             point.x, point.y);                             
		  break;   
  case ID_TOOLS_RECTROUND:
  case ID_TOOLS_RECTROUNDFILL:
		// 
	  {
         int SizeRound = (abs (m_PointOld.x - m_PointOrigin.x) +
                          abs (m_PointOld.y - m_PointOrigin.y)) / 6;
         ClientDC.RoundRect (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y,
                             SizeRound, SizeRound);
         //  
		SizeRound = (abs (point.x - m_PointOrigin.x) +
                      abs (point.y - m_PointOrigin.y)) / 6;                             
         ClientDC.RoundRect (m_PointOrigin.x, m_PointOrigin.y,
                             point.x, point.y,
                             SizeRound, SizeRound);                             
         break;  
	  }
	case ID_TOOLS_CIRCLE:   
    case ID_TOOLS_CIRCLEFILL:
         ClientDC.Ellipse (m_PointOrigin.x, m_PointOrigin.y,
                           m_PointOld.x, m_PointOld.y);
         ClientDC.Ellipse (m_PointOrigin.x, m_PointOrigin.y,
                           point.x, point.y);    
	 }
   m_PointOld = point; //  
   CScrollView::OnMouseMove(nFlags, point);
}
///////////////////////////////////////////////////////////////////
void CMiniPaintView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	
   if (!m_Dragging)
      return;

   m_Dragging = 0;
   ::ReleaseCapture (); // 
   ::ClipCursor (NULL); //     

   CClientDC ClientDC (this);//  
   OnPrepareDC (&ClientDC); //  DC
   ClientDC.DPtoLP (&point); //   
   ClientDC.SetROP2 (R2_NOT);//  
   ClientDC.SelectObject (&m_PenDotted); // 
   ClientDC.SetBkMode (TRANSPARENT); //  
   ClientDC.SelectStockObject (NULL_BRUSH);//  

   CMiniPaintApp *PApp = (CMiniPaintApp *)AfxGetApp ();//   
   CFigure *PFigure; //   

   switch (PApp->m_CurrentTool)
      {
      case ID_TOOLS_LINE: //   
         ClientDC.MoveTo (m_PointOrigin);
         ClientDC.LineTo (m_PointOld);
         PFigure = new CLine 
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor,
            PApp->m_CurrentThickness);                    
         break;

      case ID_TOOLS_RECTANGLE: //   
         ClientDC.Rectangle (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y);
         PFigure = new CRectangle
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor,
            PApp->m_CurrentThickness);                    
         break;
	  case ID_TOOLS_RECTROUND:
         {//  
        int SizeRound = (abs (m_PointOld.x - m_PointOrigin.x) + //    
            abs (m_PointOld.y - m_PointOrigin.y)) / 6;
         ClientDC.RoundRect (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y,
                             SizeRound, SizeRound);
			 
         PFigure = new CRectRound
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor,
            PApp->m_CurrentThickness);                    
         break;                    
         }
	  case ID_TOOLS_CIRCLE:   
         ClientDC.Ellipse (m_PointOrigin.x, m_PointOrigin.y,
                           m_PointOld.x, m_PointOld.y);
         PFigure = new CCircle
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor,
            PApp->m_CurrentThickness);                    
         break; 
	  case ID_TOOLS_RECTFILL:
         ClientDC.Rectangle (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y);
         PFigure = new CRectFill
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor);
         break;   
	  case ID_TOOLS_RECTROUNDFILL:
         {
         int SizeRound = (abs (m_PointOld.x - m_PointOrigin.x) +
                          abs (m_PointOld.y - m_PointOrigin.y)) / 6;
         ClientDC.RoundRect (m_PointOrigin.x, m_PointOrigin.y,
                             m_PointOld.x, m_PointOld.y,
         SizeRound, SizeRound);
         PFigure = new CRectRoundFill
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor);
         break;                    
         }      
	  case ID_TOOLS_CIRCLEFILL:
         ClientDC.Ellipse (m_PointOrigin.x, m_PointOrigin.y,
                           m_PointOld.x, m_PointOld.y);
         PFigure = new CCircleFill
            (m_PointOrigin.x, m_PointOrigin.y,
            point.x, point.y,
            PApp->m_CurrentColor);
         break;    
	  }
	  
   ClientDC.SetROP2 (R2_COPYPEN);//   
   PFigure->Draw (&ClientDC);//  
   CMiniPaintDoc* PDoc = GetDocument(); //   
   PDoc->AddFigure (PFigure); //          
   PDoc->UpdateAllViews (this, 0, PFigure);//  
   CScrollView::OnLButtonUp(nFlags, point);
   
}

/////////////////////////////////////////////////////////////
void CMiniPaintView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	//SIZE Size = {300, 300};
	SIZE Size = {DRAWWIDTH, DRAWHEIGHT};
	SetScrollSizes (MM_TEXT, Size);
}

void CMiniPaintView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pHint != 0)
	{
		CRect InvalidRect = ((CLine*)pHint)->GetDimRect();
		CClientDC ClientDC (this);
		OnPrepareDC(&ClientDC);
		ClientDC.DPtoLP(&InvalidRect);
		InvalidateRect(&InvalidRect);
	}
	else CScrollView::OnUpdate(pSender, lHint, pHint);
}




BOOL CMiniPaintView::OnPreparePrinting(CPrintInfo* pInfo)
{

	// TODO:  call DoPreparePrinting to invoke the Print dialog box

	//return CScrollView::OnPreparePrinting(pInfo);
	return DoPreparePrinting(pInfo);//   Print
}
void CMiniPaintView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Add your specialized code here and/or call the base class
	//   
	m_PageHeight = pDC->GetDeviceCaps(VERTRES);
	//   
	m_PageWidth = pDC->GetDeviceCaps(HORZRES);	
	//   
	m_NumRows = DRAWHEIGHT / m_PageHeight +
		(DRAWHEIGHT % m_PageHeight > 0);
	//   
	m_NumCols = DRAWWIDTH / m_PageWidth +
		(DRAWWIDTH % m_PageWidth > 0);
	//    
	pInfo->SetMinPage(1);
	//   
	pInfo->SetMaxPage(m_NumRows * m_NumCols);
	
	CScrollView::OnBeginPrinting(pDC, pInfo);
}

void CMiniPaintView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Add your specialized code here and/or call the base class

	CScrollView::OnPrepareDC(pDC, pInfo);

	if(pInfo == NULL) 
		return;
	//   
	int CurRow = pInfo->m_nCurPage / m_NumCols +
		(pInfo->m_nCurPage % m_NumCols > 0);
	//   
	int CurCol = (pInfo->m_nCurPage - 1) % m_NumCols + 1;
	//    
	pDC->SetViewportOrg
		(-m_PageWidth * (CurCol - 1),
		-m_PageHeight * (CurRow - 1));
}

